<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="标签名称" prop="name">
        <el-input v-model="queryParams.name" placeholder="请输入标签名称" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="标签编码" prop="labelCode">
        <el-input v-model="queryParams.labelCode" placeholder="请输入标签编码" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd" v-hasPermi="['label:labelModel:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate" v-hasPermi="['label:labelModel:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete" v-hasPermi="['label:labelModel:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" v-hasPermi="['label:labelModel:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="labelModelList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="ID" align="center" prop="id" />
      <el-table-column label="标签名称" align="center" prop="name" />
      <el-table-column label="标签编码" align="center" prop="labelCode" />
      <el-table-column label="标签内容" align="center" prop="labelValue">
        <template slot-scope="scope">
          <el-button type="text" icon="el-icon-search" @click="onShow(scope.row.labelValue)">查看</el-button>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['label:labelModel:edit']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)" v-hasPermi="['label:labelModel:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize" @pagination="getList" />

    <!-- 添加或修改标签模板信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-row>
          <el-col :span="12">
            <el-form-item label="标签名称" prop="name">
              <el-input v-model="form.name" placeholder="请输入标签名称" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="标签编码" prop="labelCode">
              <el-input v-model="form.labelCode" placeholder="请输入标签编码" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="标签内容">
              <!-- <editor v-model="form.labelValue" :min-height="192" /> -->
              <b-code-editor v-if="open" v-model="form.labelValue" :auto-format="true" :show-number="false" height="auto" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="备注" prop="remark">
              <el-input v-model="form.remark" placeholder="请输入备注" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 【调整】资产信息 -->
    <el-dialog title="标签信息" :visible.sync="isShow" width="900px" append-to-body>
      <json-viewer :value="labelInfo" :expand-depth="5" copyable boxed sort />
    </el-dialog>
  </div>
</template>

<script>
import { listLabelModel, getLabelModel, delLabelModel, addLabelModel, updateLabelModel } from '@/api/label/labelModel'

export default {
  name: 'LabelModel',
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 标签模板信息表格数据
      labelModelList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        name: null,
        labelCode: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name: [{ required: true, message: '标签名称不能为空', trigger: 'blur' }],
        labelCode: [{ required: true, message: '标签编码不能为空', trigger: 'blur' }],
        labelValue: [{ required: true, message: '标签内容不能为空', trigger: 'blur' }],
      },
      isShow: false,
      labelInfo: {},
    }
  },
  components: {},
  created() {
    this.getList()
  },
  methods: {
    onShow(val) {
      const json = JSON.parse(val)
      this.isShow = true
      this.labelInfo = json
    },
    onJsonChange(val) {
      console.log('json:', val)
    },
    /** 查询标签模板信息列表 */
    getList() {
      this.loading = true
      listLabelModel(this.queryParams).then((response) => {
        this.labelModelList = response.rows
        this.total = response.total
        this.loading = false
      })
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        name: null,
        labelCode: null,
        labelValue: null,
        remark: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
      }
      const jsonStr = JSON.stringify({
          connectType:0,
          printerName:"USB",
          connectIpAddress: null,
          connectPort: null,
          pid:300,
          isBold:true,
          epc:"${number}",
          ptxLabelTexts: [
            {
              textType:1,
              printData:"资产编码：${number}",
              spaceBetween:28,
              tffFileName:"SIMHEI.TTF",
              xLineHeight:10,
              x:20,
              y:35,
              yLineHeight:10
            },
          ],
          ptxLabelCodes:[
            {
              codeType:2,
              data:"${locationNumber}",
              spaceBetween:28,
              isShowText:false,
              X:680,
              Y:35,
              width:8,
              height:8
            }
          ]
        })
      this.form.labelValue = jsonStr
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      this.open = true
      this.title = '添加标签模板信息'
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset()
      const id = row.id || this.ids
      getLabelModel(id).then((response) => {
        this.form = response.data
        this.open = true
        this.title = '修改标签模板信息'
      })
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs['form'].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateLabelModel(this.form).then((response) => {
              this.$modal.msgSuccess('修改成功')
              this.open = false
              this.getList()
            })
          } else {
            addLabelModel(this.form).then((response) => {
              this.$modal.msgSuccess('新增成功')
              this.open = false
              this.getList()
            })
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids
      this.$modal
        .confirm('是否确认删除标签模板信息编号为"' + ids + '"的数据项？')
        .then(function () {
          return delLabelModel(ids)
        })
        .then(() => {
          this.getList()
          this.$modal.msgSuccess('删除成功')
        })
        .catch(() => {})
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        'label/labelModel/export',
        {
          ...this.queryParams,
        },
        `labelModel_${new Date().getTime()}.xlsx`
      )
    },
  },
}
</script>
